/* Copyright(C)URARA-works 2006 */
/* ========================================================================= */
/* t@CF	CharBase.cpp												 */
/* eF		LNX t@C								 */
/* 쐬F		NNt(URARA-works)								 */
/* 쐬JnF	2006/04/11													 */
/* ========================================================================= */

#include "stdafx.h"
#include "../lib/Img32.h"
#include "CharBase.h"


/* ========================================================================= */
/* ֐F	CCharBase::CCharBase											 */
/* eF	RXgN^													 */
/* tF	2006/04/11														 */
/* ========================================================================= */

CCharBase::CCharBase()
{
	m_bDestroy		= FALSE;
	m_nType			= 0;
	m_nDirection	= 0;
	m_nState		= CHARSTATE_IDLE;
	m_nState		= 0;
	m_pMgrGrpData	= NULL;
	m_pImg			= NULL;

	m_ptPos.x	= 0;
	m_ptPos.y	= 0;
}


/* ========================================================================= */
/* ֐F	CCharBase::~CCharBase											 */
/* eF	fXgN^													 */
/* tF	2006/04/11														 */
/* ========================================================================= */

CCharBase::~CCharBase()
{
	Destroy ();
}


/* ========================================================================= */
/* ֐F	CCharBase::Create												 */
/* eF	쐬															 */
/* tF	2006/04/23														 */
/* ========================================================================= */

void CCharBase::Create(CMgrGrpData *pMgrGrpData, int nType)
{
	m_pMgrGrpData	= pMgrGrpData;
	m_nType			= nType;
}


/* ========================================================================= */
/* ֐F	CCharBase::Destroy												 */
/* eF	j															 */
/* tF	2006/04/23														 */
/* ========================================================================= */

void CCharBase::Destroy(void)
{
	SAFE_DELETE (m_pImg);
}


/* ========================================================================= */
/* ֐F	CCharBase::Draw													 */
/* eF	`															 */
/* tF	2006/04/23														 */
/* ========================================================================= */

void CCharBase::Draw(CImg32 *pImgDst)
{
}


/* ========================================================================= */
/* ֐F	CCharBase::Proc													 */
/* eF																 */
/* tF	2006/04/23														 */
/* ========================================================================= */

void CCharBase::Proc(void)
{
}


/* ========================================================================= */
/* ֐F	CCharBase::ChgState												 */
/* eF	ԕύX														 */
/* tF	2006/05/06														 */
/* ========================================================================= */

void CCharBase::ChgState(int nState)
{
	m_nState = nState;
}

/* Copyright(C)URARA-works 2006 */
