/* Copyright(C)URARA-works 2005 */
/* ========================================================================= */
/* t@CF	myZlib.cpp													 */
/* eF		zlibׂ̃NX t@C							 */
/* 쐬F		NNt(URARA-works)								 */
/* 쐬JnF	2005/02/02													 */
/* ========================================================================= */

#include <windows.h>
#include "myZlib.h"

#if 0	/* ȉCӂ̃t@CɃRs[Ďgpƕ֗ */
/* libt@C̃pX */
#define LIBCMNPATH	""

/* RpCIvVʂ̃Nݒ */
#ifdef _DEBUG
	#pragma comment(lib, LIBCMNPATH "zlibD.lib")
#else
	#pragma comment(lib, LIBCMNPATH "zlib.lib")
#endif
#endif

/* ========================================================================= */
/* ֐F	CmyZlib::CmyZlib												 */
/* eF	RXgN^													 */
/* tF	2005/02/02														 */
/* ========================================================================= */

CmyZlib::CmyZlib()
{
	m_pStream = NULL;
}


/* ========================================================================= */
/* ֐F	CmyZlib::~CmyZlib												 */
/* eF	fXgN^													 */
/* tF	2005/02/02														 */
/* ========================================================================= */

CmyZlib::~CmyZlib()
{
	if (m_pStream) {
		delete m_pStream;
		m_pStream = NULL;
	}
}

/* ========================================================================= */
/* ֐F	CmyZlib::DeflateInit											 */
/* eF	k:														 */
/* tF	2005/02/02														 */
/* ========================================================================= */

BOOL CmyZlib::DeflateInit(
	int nLevel)		/* [in] kx */
{
	BOOL bRet;
	int nResult;

	bRet = FALSE;

	if (m_pStream) {
		goto Exit;
	}

	/* \̂mۂď */
	m_pStream = new z_stream;
	m_pStream->zalloc	= Z_NULL;
	m_pStream->zfree	= Z_NULL;
	m_pStream->opaque	= Z_NULL;

	/* zlib̏֐Ă */
	nResult = deflateInit (m_pStream, nLevel);
	if (nResult != Z_OK) {
		delete m_pStream;
		m_pStream = NULL;
		goto Exit;
	}

	bRet = TRUE;
Exit:
	return bRet;
}


/* ========================================================================= */
/* ֐F	CmyZlib::Deflate												 */
/* eF	k:k													 */
/* tF	2005/02/02														 */
/* ߂lF	k̃TCY													 */
/* ========================================================================= */

DWORD CmyZlib::Deflate(
	LPBYTE pSrc,			/* [in] k */
	DWORD dwSrcSize,		/* [in] kTCY */
	LPBYTE pDst,			/* [in] k */
	DWORD dwDstSize)		/* [in] kTCY */
{
	DWORD dwRet;
	int nResult;

	dwRet = 0;
	m_pStream->next_in		= pSrc;
	m_pStream->avail_in		= dwSrcSize;
	m_pStream->next_out		= pDst;
	m_pStream->avail_out	= dwDstSize;
	deflateReset(m_pStream);

	/* k */
	nResult = deflate (m_pStream, Z_FINISH);
	if (nResult == Z_STREAM_END) {
		/* k̃TCY擾 */
		dwRet = m_pStream->total_out;
	}

	return dwRet;
}


/* ========================================================================= */
/* ֐F	CmyZlib::DeflateEnd												 */
/* eF	k:㏈														 */
/* tF	2005/02/02														 */
/* ========================================================================= */

void CmyZlib::DeflateEnd(void)
{
	if (m_pStream == NULL) {
		return;
	}

	/* ㏈֐Ă */
	deflateEnd (m_pStream);

	delete m_pStream;
	m_pStream = NULL;
}


/* ========================================================================= */
/* ֐F	CmyZlib::InflateInit											 */
/* eF	:														 */
/* tF	2005/02/02														 */
/* ========================================================================= */

BOOL CmyZlib::InflateInit(void)
{
	BOOL bRet;
	int nResult;

	bRet = FALSE;

	if (m_pStream) {
		goto Exit;
	}

	/* \̂mۂď */
	m_pStream = new z_stream;
	m_pStream->zalloc	= Z_NULL;
	m_pStream->zfree	= Z_NULL;
	m_pStream->opaque	= Z_NULL;

	/* zlib̏֐Ă */
	nResult = inflateInit (m_pStream);
	if (nResult != Z_OK) {
		delete m_pStream;
		m_pStream = NULL;
		goto Exit;
	}

	bRet = TRUE;
Exit:
	return bRet;
}


/* ========================================================================= */
/* ֐F	CmyZlib::Inflate												 */
/* eF	:k													 */
/* tF	2005/02/02														 */
/* ߂lF	𓀌̃TCY													 */
/* ========================================================================= */

DWORD CmyZlib::Inflate(
	LPBYTE pSrc,			/* [in] 𓀌 */
	DWORD dwSrcSize,		/* [in] 𓀌TCY */
	LPBYTE pDst,			/* [in] 𓀐 */
	DWORD dwDstSize)		/* [in] 𓀐TCY */
{
	DWORD dwRet;
	int nResult;

	dwRet = 0;
	m_pStream->next_in		= pSrc;
	m_pStream->avail_in		= dwSrcSize;
	m_pStream->next_out		= pDst;
	m_pStream->avail_out	= dwDstSize;
	inflateReset (m_pStream);

	/*  */
	nResult = inflate (m_pStream, Z_FINISH);
	if (nResult == Z_STREAM_END) {
		/* 𓀌̃TCY擾 */
		dwRet = m_pStream->total_out;
	}

	return dwRet;
}


/* ========================================================================= */
/* ֐F	CmyZlib::InflateEnd												 */
/* eF	:㏈														 */
/* tF	2005/02/02														 */
/* ========================================================================= */

void CmyZlib::InflateEnd(void)
{
	if (m_pStream == NULL) {
		return;
	}

	/* ㏈֐Ă */
	inflateEnd (m_pStream);

	delete m_pStream;
	m_pStream = NULL;
}
/* Copyright(C)URARA-works 2005 */
